#define _GNU_SOURCE

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#include <dlfcn.h>

#include "util.h"
#include "libt.h"

// autogenerated by hijack_funcs/build.sh
#include "hijacks.h"

void __attribute__ ((constructor)) my_init(void);

void my_cacheflush(unsigned int begin, unsigned int end)
{	
	const int syscall = 0xf0002;
	__asm __volatile (
		"mov	 r0, %0\n"			
		"mov	 r1, %1\n"
		"mov	 r7, %2\n"
		"mov     r2, #0x0\n"
		"svc     0x00000000\n"
		:
		:	"r" (begin), "r" (end), "r" (syscall)
		:	"r0", "r1", "r7"
		);
}

int hook(struct hook_t *h, int pid, char *libname, char *funcname, void *hookf)
{
	unsigned long int addr;
	int i;

	if (find_name(pid, funcname, libname, &addr) < 0) {
		log("can't find: %s\n", funcname)
		return 0;
	}
	
	log("%s = 0x%x hook = 0x%x\n", funcname, addr, hookf)
	
	h->patch = (unsigned int)hookf;
	h->orig = addr;
	h->jump[0] = 0xe59ff000; // LDR pc, [pc, #0]
	h->jump[1] = h->patch;
	h->jump[2] = h->patch;
	for (i = 0; i < 3; i++)
		h->store[i] = ((int*)h->orig)[i];
	for (i = 0; i < 3; i++)
		((int*)h->orig)[i] = h->jump[i];
	
	return 1;
}

void hook_precall(struct hook_t *h)
{
	int i;
	
	for (i = 0; i < 3; i++)
		((int*)h->orig)[i] = h->store[i];
	
	my_cacheflush((unsigned int)h->orig, (unsigned int)h->orig+12);
}

void hook_postcall(struct hook_t *h)
{
	int i;
	
	for (i = 0; i < 3; i++)
		((int*)h->orig)[i] = h->jump[i];
}

// ---------------------------------------------------------------------

void my_init()
{
	log("libt loaded...\n")
	// required by macros
	int pid = getpid();
	
	HOOK_phDal4Nfc_i2c_read
	HOOK_phDal4Nfc_i2c_write
}
